Index: frontends/php/include/maps.inc.php
===================================================================
--- frontends/php/include/maps.inc.php	(revision 38884)
+++ frontends/php/include/maps.inc.php	(working copy)
@@ -60,7 +60,7 @@
 	}
 
 	function get_sysmap_by_sysmapid($sysmapid){
-		$row = DBfetch(DBselect('SELECT * FROM sysmaps WHERE sysmapid='.$sysmapid));
+		$row = DBfetch(DBselect('SELECT * FROM sysmaps WHERE sysmapid='.zbx_dbstr($sysmapid)));
 		if($row){
 			return	$row;
 		}
@@ -99,9 +99,9 @@
 
 		$result&=DBexecute('INSERT INTO sysmaps_links '.
 			' (linkid,sysmapid,label,selementid1,selementid2,drawtype,color) '.
-			' VALUES ('.$linkid.','.$link['sysmapid'].','.zbx_dbstr($link['label']).','.
-						$link['selementid1'].','.$link['selementid2'].','.
-						$link['drawtype'].','.zbx_dbstr($link['color']).')');
+			' VALUES ('.$linkid.','.zbx_dbstr($link['sysmapid']).','.zbx_dbstr($link['label']).','.
+						zbx_dbstr($link['selementid1']).','.zbx_dbstr($link['selementid2']).','.
+						zbx_dbstr($link['drawtype']).','.zbx_dbstr($link['color']).')');
 
 		if(!$result)
 			return $result;
@@ -138,13 +138,13 @@
 		}
 
 		$result&=DBexecute('UPDATE sysmaps_links SET '.
-							' sysmapid='.$link['sysmapid'].', '.
+							' sysmapid='.zbx_dbstr($link['sysmapid']).', '.
 							' label='.zbx_dbstr($link['label']).', '.
-							' selementid1='.$link['selementid1'].', '.
-							' selementid2='.$link['selementid2'].', '.
-							' drawtype='.$link['drawtype'].', '.
+							' selementid1='.zbx_dbstr($link['selementid1']).', '.
+							' selementid2='.zbx_dbstr($link['selementid2']).', '.
+							' drawtype='.zbx_dbstr($link['drawtype']).', '.
 							' color='.zbx_dbstr($link['color']).
-						' WHERE linkid='.$link['linkid']);
+						' WHERE linkid='.zbx_dbstr($link['linkid']));
 	return	$result;
 	}
 
@@ -160,7 +160,7 @@
 	function add_link_trigger($linkid,$triggerid,$drawtype,$color){
 		$linktriggerid=get_dbid("sysmaps_link_triggers","linktriggerid");
 		$sql = 'INSERT INTO sysmaps_link_triggers (linktriggerid,linkid,triggerid,drawtype,color) '.
-					" VALUES ($linktriggerid,$linkid,$triggerid,$drawtype,".zbx_dbstr($color).')';
+					' VALUES ('.zbx_dbstr($linktriggerid).','.zbx_dbstr($linkid).','.zbx_dbstr($triggerid).','.zbx_dbstr($drawtype).','.zbx_dbstr($color).')';
 	return DBexecute($sql);
 	}
 
@@ -188,7 +188,7 @@
 
 		$db_elements = DBselect('SELECT elementid, elementtype '.
 						' FROM sysmaps_elements '.
-						' WHERE sysmapid='.$elementid);
+						' WHERE sysmapid='.zbx_dbstr($elementid));
 
 		while($element = DBfetch($db_elements)){
 			if(check_circle_elements_link($sysmapid,$element["elementid"],$element["elementtype"]))
@@ -564,14 +564,14 @@
 			$resolveHostMacros = true;
 
 			if($selement['elementtype'] == SYSMAP_ELEMENT_TYPE_HOST){
-				$sql = 'SELECT host, dns, ip, useip FROM hosts WHERE hostid='.$selement['elementid'];
+				$sql = 'SELECT host, dns, ip, useip FROM hosts WHERE hostid='.zbx_dbstr($selement['elementid']);
 			}
 			else{
 				$sql ='SELECT h.host, h.dns, h.ip, h.useip'.
 					' FROM hosts h, items i, functions f'.
 					' WHERE h.hostid=i.hostid'.
 					' AND i.itemid=f.itemid'.
-					' AND f.triggerid='.$selement['elementid'];
+					' AND f.triggerid='.zbx_dbstr($selement['elementid']);
 			}
 			$db_host = DBfetch(DBselect($sql));
 		}
@@ -716,7 +716,7 @@
 				$sql = 'SELECT '.$function.'(value) as value '.
 						' FROM '.$history_table.
 						' WHERE clock>'.(time() - $parameter).
-						' AND itemid='.$item['itemid'];
+						' AND itemid='.zbx_dbstr($item['itemid']);
 				$result = DBselect($sql);
 				if(null === ($row = DBfetch($result)) || null === $row['value'])
 					$label = str_replace($expr, '('.S_NO_DATA_SMALL.')', $label);
@@ -742,7 +742,7 @@
 			case SYSMAP_ELEMENT_TYPE_MAP:
 				$sql = 'SELECT DISTINCT elementtype,elementid'.
 						' FROM sysmaps_elements'.
-						' WHERE sysmapid='.$db_element['elementid'];
+						' WHERE sysmapid='.zbx_dbstr($db_element['elementid']);
 				$db_mapselements = DBselect($sql);
 				while($db_mapelement = DBfetch($db_mapselements)){
 					get_map_elements($db_mapelement, $elements);
Index: frontends/php/include/hosts.inc.php
===================================================================
--- frontends/php/include/hosts.inc.php	(revision 38884)
+++ frontends/php/include/hosts.inc.php	(working copy)
@@ -22,7 +22,7 @@
 	function setHostGroupInternal($groupids, $internal=ZBX_NOT_INTERNAL_GROUP){
 		zbx_value2array($groupids);
 
-		$sql = 'UPDATE groups SET internal='.$internal.' WHERE '.DBcondition('groupid', $groupids);
+		$sql = 'UPDATE groups SET internal='.zbx_dbstr($internal).' WHERE '.DBcondition('groupid', $groupids);
 		$result = DBexecute($sql);
 	return $result;
 	}
@@ -67,7 +67,7 @@
 		zbx_value2array($templateids);
 
 		$result = delete_template_elements($hostid, $templateids, $unlink_mode);
-		$result&= DBexecute('DELETE FROM hosts_templates WHERE hostid='.$hostid.' AND '.DBcondition('templateid',$templateids));
+		$result&= DBexecute('DELETE FROM hosts_templates WHERE hostid='.zbx_dbstr($hostid).' AND '.DBcondition('templateid',$templateids));
 	return $result;
 	}
 
@@ -274,7 +274,7 @@
 // delete host
 		foreach($hostids as $id){	/* The section should be improved */
 			$host_old = get_host_by_hostid($id);
-			$result = DBexecute('DELETE FROM hosts WHERE hostid='.$id);
+			$result = DBexecute('DELETE FROM hosts WHERE hostid='.zbx_dbstr($id));
 			if($result){
 				if($host_old['status'] == HOST_STATUS_TEMPLATE){
 					info(S_TEMPLATE.SPACE.$host_old['host'].SPACE.S_HOST_HAS_BEEN_DELETED_MSG_PART2);
@@ -389,7 +389,7 @@
 
 		foreach ($groupids as $id) {	/* The section should be improved */
 			$hostgroup_old = get_hostgroup_by_groupid($id);
-			$result = DBexecute('DELETE FROM groups WHERE groupid='.$id);
+			$result = DBexecute('DELETE FROM groups WHERE groupid='.zbx_dbstr($id));
 			if ($result)
 				add_audit_ext(AUDIT_ACTION_DELETE, AUDIT_RESOURCE_HOST_GROUP, $id, $hostgroup_old['name'], 'groups', NULL, NULL);
 			else
@@ -400,7 +400,7 @@
 	}
 
 	function get_hostgroup_by_groupid($groupid){
-		$result=DBselect("select * from groups where groupid=".$groupid);
+		$result=DBselect("select * from groups where groupid=".zbx_dbstr($groupid));
 		$row=DBfetch($result);
 		if($row){
 			return $row;
@@ -421,7 +421,7 @@
 		else
 			$result = DBselect('SELECT * FROM hosts WHERE status IN ('.HOST_STATUS_PROXY_ACTIVE.','.HOST_STATUS_PROXY_PASSIVE.')'.
 					' and '.DBin_node('hostid').' AND host='.zbx_dbstr($name).
-					' and hostid<>'.$proxyid);
+					' and hostid<>'.zbx_dbstr($proxyid));
 
 		if(DBfetch($result)){
 			error(S_PROXY.SPACE."'$name'".SPACE.S_ALREADY_EXISTS_SMALL);
@@ -431,7 +431,7 @@
 		if(is_null($proxyid)){
 			$proxyid=get_dbid('hosts','hostid');
 			if(!DBexecute('INSERT INTO hosts (hostid,host,status,useip,dns,ip,port)'.
-				' values ('.$proxyid.','.zbx_dbstr($name).','.$status.','.$useip.','.zbx_dbstr($dns).','.zbx_dbstr($ip).','.$port.')'))
+				' values ('.$proxyid.','.zbx_dbstr($name).','.zbx_dbstr($status).','.zbx_dbstr($useip).','.zbx_dbstr($dns).','.zbx_dbstr($ip).','.zbx_dbstr($port).')'))
 			{
 				return false;
 			}
@@ -439,7 +439,7 @@
 			return $proxyid;
 		}
 		else
-			return DBexecute('update hosts set host='.zbx_dbstr($name).',status='.$status.',useip='.$useip.',dns='.zbx_dbstr($dns).',ip='.zbx_dbstr($ip).',port='.$port.' where hostid='.$proxyid);
+			return DBexecute('update hosts set host='.zbx_dbstr($name).',status='.zbx_dbstr($status).',useip='.zbx_dbstr($useip).',dns='.zbx_dbstr($dns).',ip='.zbx_dbstr($ip).',port='.zbx_dbstr($port).' where hostid='.zbx_dbstr($proxyid));
 	}
 
 	function delete_proxy($proxyids){
@@ -474,10 +474,10 @@
 	}
 
 	function update_hosts_by_proxyid($proxyid,$hosts=array()){
-		DBexecute('update hosts set proxy_hostid=0 where proxy_hostid='.$proxyid);
+		DBexecute('update hosts set proxy_hostid=0 where proxy_hostid='.zbx_dbstr($proxyid));
 
 		foreach($hosts as $hostid){
-			DBexecute('update hosts set proxy_hostid='.$proxyid.' where hostid='.$hostid);
+			DBexecute('update hosts set proxy_hostid='.zbx_dbstr($proxyid).' where hostid='.zbx_dbstr($hostid));
 		}
 	}
 
@@ -532,7 +532,7 @@
 	}
 
 	function get_host_by_hostid($hostid,$no_error_message=0){
-		$sql='SELECT * FROM hosts WHERE hostid='.$hostid;
+		$sql='SELECT * FROM hosts WHERE hostid='.zbx_dbstr($hostid);
 		$result=DBselect($sql);
 		$row=DBfetch($result);
 		if($row){
@@ -570,7 +570,7 @@
 			if($status != $host['status']){
 //				$hosts[$host['hostid']] = $host['hostid'];
 				update_trigger_value_to_unknown_by_hostid($host['hostid']);
-				$res = DBexecute('UPDATE hosts SET status='.$status.' WHERE hostid='.$host['hostid']);
+				$res = DBexecute('UPDATE hosts SET status='.zbx_dbstr($status).' WHERE hostid='.zbx_dbstr($host['hostid']));
 				if($res){
 					$host_new = $host;//get_host_by_hostid($host['hostid']);
 					$host_new['status'] = $status;
@@ -613,7 +613,7 @@
 		$db_templates = DBselect('SELECT DISTINCT h.hostid,h.host '.
 				' FROM hosts_templates ht '.
 					' LEFT JOIN hosts h ON h.hostid=ht.templateid '.
-				' WHERE ht.hostid='.$hostid.
+				' WHERE ht.hostid='.zbx_dbstr($hostid).
 				' ORDER BY h.host');
 
 		while($template_data = DBfetch($db_templates)){
@@ -1153,7 +1153,7 @@
 
 		if($_REQUEST['groupid'] > 0){
 			if($_REQUEST['hostid'] > 0){
-				$sql = 'SELECT groupid FROM hosts_groups WHERE hostid='.$_REQUEST['hostid'].' AND groupid='.$_REQUEST['groupid'];
+				$sql = 'SELECT groupid FROM hosts_groups WHERE hostid='.zbx_dbstr($_REQUEST['hostid']).' AND groupid='.zbx_dbstr($_REQUEST['groupid']);
 				if(!DBfetch(DBselect($sql))){
 					$_REQUEST['hostid'] = 0;
 				}
@@ -1265,9 +1265,9 @@
 		$sql = 'SELECT applicationid, templateid
 			FROM applications
 			WHERE name='.zbx_dbstr($name).'
-				AND hostid='.$hostid;
+				AND hostid='.zbx_dbstr($hostid);
 		if(!is_null($applicationid)){
-			$sql .= ' AND applicationid<>'.$applicationid;
+			$sql .= ' AND applicationid<>'.zbx_dbstr($applicationid);
 		}
 		$db_app = DBfetch(DBselect($sql));
 		if($db_app && (($templateid == 0) || ($templateid && $db_app['templateid'] && $templateid != $db_app['templateid']))){
@@ -1290,15 +1290,15 @@
 			$applicationid_new = get_dbid('applications', 'applicationid');
 
 			$sql = 'INSERT INTO applications (applicationid, name, hostid, templateid) '.
-				" VALUES ($applicationid_new, ".zbx_dbstr($name).", $hostid, $templateid)";
+				' VALUES ('.zbx_dbstr($applicationid_new).','.zbx_dbstr($name).','.zbx_dbstr($hostid).','.zbx_dbstr($templateid).')';
 			if($result = DBexecute($sql)){
 				info(S_ADDED_NEW_APPLICATION.SPACE.'"'.$host['host'].':'.$name.'"');
 			}
 		}
 		else{
 			$old_app = get_application_by_applicationid($applicationid);
-			$result = DBexecute('UPDATE applications SET name='.zbx_dbstr($name).', hostid='.$hostid.', templateid='.$templateid.
-				' WHERE applicationid='.$applicationid);
+			$result = DBexecute('UPDATE applications SET name='.zbx_dbstr($name).', hostid='.zbx_dbstr($hostid).', templateid='.zbx_dbstr($templateid).
+				' WHERE applicationid='.zbx_dbstr($applicationid));
 			if($result)
 				info(S_APPLICATION.SPACE.'"'.$host['host'].':'.$old_app['name'].'"'.SPACE.S_UPDATED_SMALL);
 		}
@@ -1437,7 +1437,7 @@
 	}
 
 	function get_application_by_applicationid($applicationid,$no_error_message=0){
-		$result = DBselect("select * from applications where applicationid=".$applicationid);
+		$result = DBselect('select * from applications where applicationid='.zbx_dbstr($applicationid));
 		$row=DBfetch($result);
 		if($row)
 		{
@@ -1450,7 +1450,7 @@
 	}
 
 	function get_applications_by_templateid($applicationid){
-		return DBselect("select * from applications where templateid=".$applicationid);
+		return DBselect('select * from applications where templateid='.zbx_dbstr($applicationid));
 	}
 
 	function get_realhost_by_applicationid($applicationid){
@@ -1462,7 +1462,7 @@
 	}
 
 	function get_host_by_applicationid($applicationid){
-		$sql="select h.* from hosts h, applications a where a.hostid=h.hostid and a.applicationid=$applicationid";
+		$sql='select h.* from hosts h, applications a where a.hostid=h.hostid and a.applicationid='.zbx_dbstr($applicationid);
 		$result=DBselect($sql);
 		$row=DBfetch($result);
 		if($row)
@@ -1474,7 +1474,7 @@
 	}
 
 	function get_applications_by_hostid($hostid){
-		return DBselect('select * from applications where hostid='.$hostid);
+		return DBselect('select * from applications where hostid='.zbx_dbstr($hostid));
 	}
 
 	/*
@@ -1513,7 +1513,7 @@
 			}
 
 			if ($unlink_mode) {
-				if (DBexecute("update applications set templateid=0 where applicationid=".$db_app["applicationid"])) {
+				if (DBexecute("update applications set templateid=0 where applicationid=".zbx_dbstr($db_app["applicationid"]))) {
 					info(S_APPLICATION.SPACE.'"'.$host["host"].':'.$db_app["name"].'"'.SPACE.S_UNLINKED_SMALL);
 				}
 			}
@@ -1612,7 +1612,7 @@
 
 	function add_host_profile($hostid,$devicetype,$name,$os,$serialno,$tag,$macaddress,$hardware,$software,$contact,$location,$notes){
 
-		$result=DBselect('SELECT * FROM hosts_profiles WHERE hostid='.$hostid);
+		$result=DBselect('SELECT * FROM hosts_profiles WHERE hostid='.zbx_dbstr($hostid));
 		if(DBfetch($result)){
 			error(S_HOST_PROFILE.SPACE.S_ALREADY_EXISTS);
 			return 0;
@@ -1653,7 +1653,7 @@
 			'poc_1_name','poc_1_email','poc_1_phone_1','poc_1_phone_2','poc_1_cell','poc_1_screen','poc_1_notes','poc_2_name',
 			'poc_2_email','poc_2_phone_1','poc_2_phone_2','poc_2_cell','poc_2_screen','poc_2_notes');
 
-		$result=DBselect('SELECT * FROM hosts_profiles_ext WHERE hostid='.$hostid);
+		$result=DBselect('SELECT * FROM hosts_profiles_ext WHERE hostid='.zbx_dbstr($hostid));
 		if(DBfetch($result)){
 			error(S_HOST_PROFILE.SPACE.S_ALREADY_EXISTS);
 			return false;
Index: frontends/php/include/users.inc.php
===================================================================
--- frontends/php/include/users.inc.php	(revision 38884)
+++ frontends/php/include/users.inc.php	(working copy)
@@ -91,11 +91,11 @@
 	function add_user_to_group($userid,$usrgrpid){
 		$result = false;
 		if(granted2move_user($userid,$usrgrpid)){
-			DBexecute('DELETE FROM users_groups WHERE userid='.$userid.' AND usrgrpid='.$usrgrpid);
+			DBexecute('DELETE FROM users_groups WHERE userid='.zbx_dbstr($userid).' AND usrgrpid='.zbx_dbstr($usrgrpid));
 
 			$users_groups_id = get_dbid("users_groups","id");
 			$result = DBexecute('INSERT INTO users_groups (id,usrgrpid,userid) '.
-									' VALUES ('.$users_groups_id.','.$usrgrpid.','.$userid.')');
+									' VALUES ('.$users_groups_id.','.zbx_dbstr($usrgrpid).','.zbx_dbstr($userid).')');
 		}
 		else{
 			error(S_USER_CANNOT_CHANGE_STATUS);
@@ -106,7 +106,7 @@
 	function remove_user_from_group($userid,$usrgrpid){
 		$result = false;
 		if(granted2move_user($userid,$usrgrpid)){
-			$result = DBexecute('DELETE FROM users_groups WHERE userid='.$userid.' AND usrgrpid='.$usrgrpid);
+			$result = DBexecute('DELETE FROM users_groups WHERE userid='.zbx_dbstr($userid).' AND usrgrpid='.zbx_dbstr($usrgrpid));
 		}
 		else{
 			error(S_USER_CANNOT_CHANGE_STATUS);
@@ -156,7 +156,7 @@
 		if($users_status == GROUP_STATUS_DISABLED) $grant = granted2update_group($usrgrpids);
 
 		if($grant)
-			$res = DBexecute('UPDATE usrgrp SET users_status='.$users_status.' WHERE '.DBcondition('usrgrpid',$usrgrpids));
+			$res = DBexecute('UPDATE usrgrp SET users_status='.zbx_dbstr($users_status).' WHERE '.DBcondition('usrgrpid',$usrgrpids));
 		else
 			error(S_USER_CANNOT_CHANGE_STATUS);
 
@@ -172,7 +172,7 @@
 		if($gui_access == GROUP_GUI_ACCESS_DISABLED) $grant = granted2update_group($usrgrpids);
 
 		if($grant)
-			$res = DBexecute('UPDATE usrgrp SET gui_access='.$gui_access.' WHERE '.DBcondition('usrgrpid',$usrgrpids));
+			$res = DBexecute('UPDATE usrgrp SET gui_access='.zbx_dbstr($gui_access).' WHERE '.DBcondition('usrgrpid',$usrgrpids));
 		else
 			error(S_USER_CANNOT_CHANGE_GUI_ACCESS);
 
@@ -182,14 +182,14 @@
 	function change_group_api_access($usrgrpids, $api_access){
 		zbx_value2array($usrgrpids);
 		$res = false;
-		$res = DBexecute('UPDATE usrgrp SET api_access='.$api_access.' WHERE '.DBcondition('usrgrpid',$usrgrpids));
+		$res = DBexecute('UPDATE usrgrp SET api_access='.zbx_dbstr($api_access).' WHERE '.DBcondition('usrgrpid',$usrgrpids));
 	return $res;
 	}
 
 	function change_group_debug_mode($usrgrpids, $debug_mode){
 		zbx_value2array($usrgrpids);
 		$res = false;
-		$res = DBexecute('UPDATE usrgrp SET debug_mode='.$debug_mode.' WHERE '.DBcondition('usrgrpid',$usrgrpids));
+		$res = DBexecute('UPDATE usrgrp SET debug_mode='.zbx_dbstr($debug_mode).' WHERE '.DBcondition('usrgrpid',$usrgrpids));
 	return $res;
 	}
 ?>
Index: frontends/php/include/events.inc.php
===================================================================
--- frontends/php/include/events.inc.php	(revision 38884)
+++ frontends/php/include/events.inc.php	(working copy)
@@ -30,7 +30,7 @@
 	function get_tr_event_by_eventid($eventid){
 		$sql = 'SELECT e.*,t.triggerid, t.description,t.priority,t.status,t.type,t.expression '.
 				' FROM events e,triggers t '.
-				' WHERE e.eventid='.$eventid.
+				' WHERE e.eventid='.zbx_dbstr($eventid).
 					' AND e.object='.EVENT_OBJECT_TRIGGER.
 					' AND t.triggerid=e.objectid';
 		$result = DBfetch(DBselect($sql));
@@ -116,7 +116,7 @@
 	if(empty($events)){
 		$sql = 'SELECT e.eventid '.
 				' FROM events e '.
-				' WHERE e.objectid='.$row['triggerid'].$sql_cond.
+				' WHERE e.objectid='.zbx_dbstr($row['triggerid']).$sql_cond.
 					' AND e.object='.EVENT_OBJECT_TRIGGER.
 				' ORDER BY e.object, e.objectid, e.eventid';
 		$res = DBselect($sql,1);
@@ -127,8 +127,8 @@
 		$eventid = $events[0]['eventid'];
 		$sql = 'SELECT e.eventid '.
 				' FROM events e '.
-				' WHERE e.eventid > '.$eventid.
-					' AND e.objectid='.$row['triggerid'].$sql_cond.
+				' WHERE e.eventid > '.zbx_dbstr($eventid).
+					' AND e.objectid='.zbx_dbstr($row['triggerid']).$sql_cond.
 					' AND e.object='.EVENT_OBJECT_TRIGGER.
 				' ORDER BY e.object, e.objectid, e.eventid';
 		$res = DBselect($sql,1);
@@ -147,10 +147,10 @@
 
 		$sql = 'SELECT e.eventid,e.clock '.
 				' FROM events e '.
-				' WHERE e.eventid > '.$eventid.
-					' AND e.objectid='.$row['triggerid'].
+				' WHERE e.eventid > '.zbx_dbstr($eventid).
+					' AND e.objectid='.zbx_dbstr($row['triggerid']).
 					' AND e.object='.EVENT_OBJECT_TRIGGER.
-					' AND e.value='.$row['value'].
+					' AND e.value='.zbx_dbstr($row['value']).
 				' ORDER BY e.object, e.objectid, e.eventid';
 		$res = DBselect($sql,1);
 		$rows = DBfetch($res);
@@ -179,8 +179,8 @@
 
 	$sql = 'SELECT e.eventid, e.clock, e.value '.
 			' FROM events e '.
-			' WHERE e.objectid='.$row['triggerid'].
-				' AND e.eventid < '.$row['eventid'].
+			' WHERE e.objectid='.zbx_dbstr($row['triggerid']).
+				' AND e.eventid < '.zbx_dbstr($row['eventid']).
 				' AND e.object='.EVENT_OBJECT_TRIGGER.
 				' AND e.value='.TRIGGER_VALUE_FALSE.
 			' ORDER BY e.object DESC, e.objectid DESC, e.eventid DESC';
@@ -188,8 +188,8 @@
 
 	$sql = 'SELECT e.eventid, e.clock, e.value '.
 			' FROM events e'.
-			' WHERE e.objectid='.$row['triggerid'].
-				' AND e.eventid < '.$row['eventid'].
+			' WHERE e.objectid='.zbx_dbstr($row['triggerid']).
+				' AND e.eventid < '.zbx_dbstr($row['eventid']).
 				' AND e.object='.EVENT_OBJECT_TRIGGER.
 				' AND e.value='.TRIGGER_VALUE_TRUE.
 			' ORDER BY e.object DESC, e.objectid DESC, e.eventid DESC';
@@ -199,8 +199,8 @@
 	if($hide_unknown == 0){
 		$sql = 'SELECT e.eventid, e.clock, e.value '.
 				' FROM events e'.
-				' WHERE e.objectid='.$row['triggerid'].
-					' AND e.eventid < '.$row['eventid'].
+				' WHERE e.objectid='.zbx_dbstr($row['triggerid']).
+					' AND e.eventid < '.zbx_dbstr($row['eventid']).
 					' AND e.object='.EVENT_OBJECT_TRIGGER.
 					' AND e.value='.TRIGGER_VALUE_UNKNOWN.
 				' ORDER BY e.object DESC, e.objectid DESC, e.eventid DESC';
@@ -239,8 +239,8 @@
 
 	$sql = 'SELECT e.eventid, e.value, e.clock '.
 		' FROM events e'.
-		' WHERE e.objectid='.$event['objectid'].
-			' AND e.eventid>'.$event['eventid'].
+		' WHERE e.objectid='.zbx_dbstr($event['objectid']).
+			' AND e.eventid>'.zbx_dbstr($event['eventid']).
 			' AND e.object='.EVENT_OBJECT_TRIGGER.
 		' ORDER BY e.object, e.objectid, e.eventid';
 
@@ -405,9 +405,9 @@
 	$event_list = array();
 	$sql = 'SELECT * '.
 			' FROM events '.
-			' WHERE eventid<='.$eventid.
+			' WHERE eventid<='.zbx_dbstr($eventid).
 				' AND object='.EVENT_OBJECT_TRIGGER.
-				' AND objectid='.$triggerid.
+				' AND objectid='.zbx_dbstr($triggerid).
 			' ORDER BY eventid DESC';
 	$db_events = DBselect($sql, ZBX_WIDGET_ROWS);
 
Index: frontends/php/include/images.inc.php
===================================================================
--- frontends/php/include/images.inc.php	(revision 38884)
+++ frontends/php/include/images.inc.php	(working copy)
@@ -29,7 +29,7 @@
 			$sql = 'SELECT i.imageid '.
 				' FROM images i '.
 				' WHERE '.DBin_node('i.imageid', false).
-					' AND imagetype='.$imagetype.
+					' AND imagetype='.zbx_dbstr($imagetype).
 				' ORDER BY name ASC';
 			$result = DBselect($sql,1);
 			if($image = DBfetch($result)) return $image;
@@ -44,7 +44,7 @@
 
 	function get_image_by_imageid($imageid){
 
-		$sql = 'SELECT * FROM images WHERE imageid='.$imageid;
+		$sql = 'SELECT * FROM images WHERE imageid='.zbx_dbstr($imageid);
 		$result = DBselect($sql);
 		if($row = DBfetch($result)){
 			$row['image'] = zbx_unescape_image($row['image']);
Index: frontends/php/include/maintenances.inc.php
===================================================================
--- frontends/php/include/maintenances.inc.php	(revision 38884)
+++ frontends/php/include/maintenances.inc.php	(working copy)
@@ -25,7 +25,7 @@
 	$sql = 'SELECT m.* '.
 			' FROM maintenances m '.
 			' WHERE '.DBin_node('m.maintenanceid').
-				' AND maintenanceid='.$maintenanceid;
+				' AND maintenanceid='.zbx_dbstr($maintenanceid);
 
 	$maintenance = DBfetch(DBselect($sql));
 return $maintenance;
Index: frontends/php/include/audit.inc.php
===================================================================
--- frontends/php/include/audit.inc.php	(revision 38884)
+++ frontends/php/include/audit.inc.php	(working copy)
@@ -81,7 +81,7 @@
 
 		if(($result = DBexecute('INSERT INTO auditlog (auditid,userid,clock,action,resourcetype,details,ip) '.
 			' VALUES ('.$auditid.','.$USER_DETAILS['userid'].','.time().','.
-						$action.','.$resourcetype.','.zbx_dbstr($details).','.
+						zbx_dbstr($action).','.zbx_dbstr($resourcetype).','.zbx_dbstr($details).','.
 						zbx_dbstr($ip).')')))
 		{
 			$result = $auditid;
@@ -120,7 +120,7 @@
 
 		$result = DBexecute('INSERT INTO auditlog (auditid,userid,clock,ip,action,resourcetype,resourceid,resourcename)'.
 				' values ('.$auditid.','.$USER_DETAILS['userid'].','.time().','.zbx_dbstr($ip).
-				','.$action.','.$resourcetype.','.$resourceid.','.zbx_dbstr($resourcename).')');
+				','.zbx_dbstr($action).','.zbx_dbstr($resourcetype).','.zbx_dbstr($resourceid).','.zbx_dbstr($resourcename).')');
 
 		if ($result && $action == AUDIT_ACTION_UPDATE) {
 			foreach ($values_diff as $id) {
Index: frontends/php/include/discovery.inc.php
===================================================================
--- frontends/php/include/discovery.inc.php	(revision 38884)
+++ frontends/php/include/discovery.inc.php	(working copy)
@@ -146,11 +146,11 @@
 	}
 
 	function get_discovery_rule_by_druleid($druleid){
-		return DBfetch(DBselect('select * from drules where druleid='.$druleid));
+		return DBfetch(DBselect('select * from drules where druleid='.zbx_dbstr($druleid)));
 	}
 
 	function set_discovery_rule_status($druleid, $status){
-		return DBexecute('update drules set status='.$status.' where druleid='.$druleid);
+		return DBexecute('update drules set status='.zbx_dbstr($status).' where druleid='.zbx_dbstr($druleid));
 	}
 
 	function add_discovery_check($druleid, $type, $ports, $key, $snmp_community,
@@ -168,9 +168,9 @@
 		$dcheckid = get_dbid('dchecks', 'dcheckid');
 		$result = DBexecute('insert into dchecks (dcheckid,druleid,type,ports,key_,snmp_community'.
 				',snmpv3_securityname,snmpv3_securitylevel,snmpv3_authpassphrase,snmpv3_privpassphrase) '.
-				' values ('.$dcheckid.','.$druleid.','.$type.','.zbx_dbstr($ports).','.
+				' values ('.$dcheckid.','.zbx_dbstr($druleid).','.zbx_dbstr($type).','.zbx_dbstr($ports).','.
 				zbx_dbstr($key).','.zbx_dbstr($snmp_community).','.zbx_dbstr($snmpv3_securityname).','.
-				$snmpv3_securitylevel.','.zbx_dbstr($snmpv3_authpassphrase).','.zbx_dbstr($snmpv3_privpassphrase).')');
+				zbx_dbstr($snmpv3_securitylevel).','.zbx_dbstr($snmpv3_authpassphrase).','.zbx_dbstr($snmpv3_privpassphrase).')');
 
 		if(!$result)
 			return $result;
@@ -192,7 +192,7 @@
 
 		$druleid = get_dbid('drules', 'druleid');
 		$result = DBexecute('insert into drules (druleid,proxy_hostid,name,iprange,delay,status) '.
-			' values ('.$druleid.','.$proxy_hostid.','.zbx_dbstr($name).','.zbx_dbstr($iprange).','.$delay.','.$status.')');
+			' values ('.$druleid.','.zbx_dbstr($proxy_hostid).','.zbx_dbstr($name).','.zbx_dbstr($iprange).','.zbx_dbstr($delay).','.zbx_dbstr($status).')');
 
 		if($result && isset($dchecks)){
 			$unique_dcheckid = 0;
@@ -204,8 +204,8 @@
 					$unique_dcheckid = $data['dcheckid'];
 			}
 			DBexecute('UPDATE drules'.
-					' SET unique_dcheckid='.$unique_dcheckid.
-					' WHERE druleid='.$druleid);
+					' SET unique_dcheckid='.zbx_dbstr($unique_dcheckid).
+					' WHERE druleid='.zbx_dbstr($druleid));
 
 			$result = $druleid;
 		}
@@ -229,8 +229,8 @@
 			}
 		}
 
-		$result = DBexecute('update drules set proxy_hostid='.$proxy_hostid.',name='.zbx_dbstr($name).',iprange='.zbx_dbstr($iprange).','.
-			'delay='.$delay.',status='.$status.' where druleid='.$druleid);
+		$result = DBexecute('update drules set proxy_hostid='.zbx_dbstr($proxy_hostid).',name='.zbx_dbstr($name).',iprange='.zbx_dbstr($iprange).','.
+			'delay='.zbx_dbstr($delay).',status='.zbx_dbstr($status).' where druleid='.zbx_dbstr($druleid));
 
 		if($result && isset($dchecks)){
 			$unique_dcheckid = 0;
@@ -245,8 +245,8 @@
 			}
 
 			DBexecute('UPDATE drules'.
-					' SET unique_dcheckid='.$unique_dcheckid.
-					' WHERE druleid='.$druleid);
+					' SET unique_dcheckid='.zbx_dbstr($unique_dcheckid).
+					' WHERE druleid='.zbx_dbstr($druleid));
 		}
 
 		if($result && isset($dchecks_deleted) && !empty($dchecks_deleted))
@@ -292,7 +292,7 @@
 		$sql = 'SELECT DISTINCT actionid '.
 				' FROM conditions '.
 				' WHERE conditiontype='.CONDITION_TYPE_DRULE.
-					" AND value='$druleid'";
+					' AND value='.zbx_dbstr($druleid);
 
 		$db_actions = DBselect($sql);
 		while($db_action = DBfetch($db_actions))
@@ -307,26 +307,26 @@
 // delete action conditions
 			DBexecute('DELETE FROM conditions '.
 					' WHERE conditiontype='.CONDITION_TYPE_DRULE.
-					" AND value='$druleid'");
+					' AND value='.zbx_dbstr($druleid));
 		}
 
 		if($result){
 			$db_dhosts = DBselect('select dhostid from dhosts'.
-					' where druleid='.$druleid.' and '.DBin_node('dhostid'));
+					' where druleid='.zbx_dbstr($druleid).' and '.DBin_node('dhostid'));
 
 			while ($result && ($db_dhost = DBfetch($db_dhosts)))
 				$result = DBexecute('delete from dservices where'.
-						' dhostid='.$db_dhost['dhostid']);
+						' dhostid='.zbx_dbstr($db_dhost['dhostid']));
 		}
 
 		if ($result)
-			$result = DBexecute('delete from dhosts where druleid='.$druleid);
+			$result = DBexecute('delete from dhosts where druleid='.zbx_dbstr($druleid));
 
 		if ($result)
-			$result = DBexecute('delete from dchecks where druleid='.$druleid);
+			$result = DBexecute('delete from dchecks where druleid='.zbx_dbstr($druleid));
 
 		if ($result)
-			$result = DBexecute('delete from drules where druleid='.$druleid);
+			$result = DBexecute('delete from drules where druleid='.zbx_dbstr($druleid));
 
 		return $result;
 	}
Index: frontends/php/include/nodes.inc.php
===================================================================
--- frontends/php/include/nodes.inc.php	(revision 38884)
+++ frontends/php/include/nodes.inc.php	(working copy)
@@ -30,7 +30,7 @@
 		foreach($nodeids as $nodeid){
 			$profileid = get_dbid('profiles', 'profileid');
 			$sql='INSERT INTO profiles (profileid, userid, idx, value_id, type)'.
-				' VALUES ('.$profileid.','.$USER_DETAILS['userid'].', '.zbx_dbstr('web.nodes.selected').','.$nodeid.', 4)';
+				' VALUES ('.$profileid.','.$USER_DETAILS['userid'].', '.zbx_dbstr('web.nodes.selected').','.zbx_dbstr($nodeid).', 4)';
 			DBexecute($sql);
 		}
 
@@ -287,19 +287,19 @@
 		}
 
 
-		if(DBfetch(DBselect('SELECT nodeid FROM nodes WHERE nodeid='.$new_nodeid))){
+		if(DBfetch(DBselect('SELECT nodeid FROM nodes WHERE nodeid='.zbx_dbstr($new_nodeid)))){
 			error(S_NODE_WITH_SAME_ID_ALREADY_EXISTS);
 			return false;
 		}
 
 		$nodetype = 0;
 		$sql = 'INSERT INTO nodes (nodeid,name,timezone,ip,port,slave_history,slave_trends, nodetype,masterid) '.
-			' VALUES ('.$new_nodeid.','.zbx_dbstr($name).','.$timezone.','.zbx_dbstr($ip).','.$port.','.$slave_history.','.
-			$slave_trends.','.$nodetype.','.$masterid.')';
+			' VALUES ('.zbx_dbstr($new_nodeid).','.zbx_dbstr($name).','.zbx_dbstr($timezone).','.zbx_dbstr($ip).','.zbx_dbstr($port).','.zbx_dbstr($slave_history).','.
+			zbx_dbstr($slave_trends).','.zbx_dbstr($nodetype).','.zbx_dbstr($masterid).')';
 		$result = DBexecute($sql);
 
 		if($result && $node_type == ZBX_NODE_MASTER){
-			DBexecute('UPDATE nodes SET masterid='.$new_nodeid.' WHERE nodeid='.$ZBX_LOCALNODEID);
+			DBexecute('UPDATE nodes SET masterid='.zbx_dbstr($new_nodeid).' WHERE nodeid='.$ZBX_LOCALNODEID);
 			$ZBX_CURMASTERID = $new_nodeid; /* apply Master node for this script */
 		}
 
@@ -313,16 +313,16 @@
 			return false;
 		}
 
-		$result = DBexecute('UPDATE nodes SET nodeid='.$new_nodeid.',name='.zbx_dbstr($name).','.
-			'timezone='.$timezone.',ip='.zbx_dbstr($ip).',port='.$port.','.
-			'slave_history='.$slave_history.',slave_trends='.$slave_trends.
-			' WHERE nodeid='.$nodeid);
+		$result = DBexecute('UPDATE nodes SET nodeid='.zbx_dbstr($new_nodeid).',name='.zbx_dbstr($name).','.
+			'timezone='.zbx_dbstr($timezone).',ip='.zbx_dbstr($ip).',port='.zbx_dbstr($port).','.
+			'slave_history='.zbx_dbstr($slave_history).',slave_trends='.zbx_dbstr($slave_trends).
+			' WHERE nodeid='.zbx_dbstr($nodeid));
 	return $result;
 	}
 
 	function delete_node($nodeid){
 		$result = false;
-		$node_data = DBfetch(DBselect('select * from nodes where nodeid='.$nodeid));
+		$node_data = DBfetch(DBselect('select * from nodes where nodeid='.zbx_dbstr($nodeid)));
 
 		$node_type = detect_node_type($node_data);
 
@@ -334,8 +334,8 @@
 			$result = (
 				// DBexecute("insert into housekeeper (housekeeperid,tablename,field,value)".
 					// " values ($housekeeperid,'nodes','nodeid',$nodeid)") &&
-				DBexecute('delete from nodes where nodeid='.$nodeid) &&
-				DBexecute('update nodes set masterid=0 where masterid='.$nodeid)
+				DBexecute('delete from nodes where nodeid='.zbx_dbstr($nodeid)) &&
+				DBexecute('update nodes set masterid=0 where masterid='.zbx_dbstr($nodeid))
 				);
 			error(S_DATABASE_STILL_CONTAINS_DATA_RELATED_DELETED_NODE);
 		}
@@ -345,7 +345,7 @@
 
 	function get_node_by_nodeid($nodeid)
 	{
-		return DBfetch(DBselect('select * from nodes where nodeid='.$nodeid));
+		return DBfetch(DBselect('select * from nodes where nodeid='.zbx_dbstr($nodeid)));
 	}
 
 	function get_node_path($nodeid, $result='/')
